Last Comment Bug 300765 - Strange flickering with graphical links in this testcase
: Strange flickering with graphical links in this testcase
Status: VERIFIED FIXED
: regression, testcase, verified1.8.0.1, verified1.8.1
Product: Core
Classification: Components
Component: DOM: Events (show other bugs)
: Trunk
: All All
: -- normal (vote)
: mozilla1.8.1
Assigned To: events
: Hixie (not reading bugmail)
Mentors:
http://www.liveforspeed.net
Depends on: 105894
Blocks: 250006
  Show dependency treegraph
 
Reported: 2005-07-14 05:40 PDT by Steve England [:stevee]
Modified: 2006-03-12 18:42 PST (History)
7 users (show)
asa: blocking1.8b5-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
image 1 for testcase (3.07 KB, image/gif)
2005-07-14 05:41 PDT, Steve England [:stevee]
no flags Details
image 2 for testcase (2.86 KB, image/gif)
2005-07-14 05:41 PDT, Steve England [:stevee]
no flags Details
image 3 for testcase (4.40 KB, image/gif)
2005-07-14 05:41 PDT, Steve England [:stevee]
no flags Details
testcase (2.37 KB, text/html)
2005-07-14 05:44 PDT, Steve England [:stevee]
no flags Details
image for testcase2 (1.17 KB, image/gif)
2005-07-14 13:04 PDT, Martijn Wargers [:mwargers] (not working for Mozilla)
no flags Details
testcase2 (923 bytes, text/html)
2005-07-14 13:16 PDT, Martijn Wargers [:mwargers] (not working for Mozilla)
no flags Details

Description Steve England [:stevee] 2005-07-14 05:40:41 PDT
Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.8b3) Gecko/20050714
Firefox/1.0+ ID:2005071403

This bug is a regression, as discovered from www.liveforspeed.net
Clicking on the graphical links causes the links to flicker like mad. This
happens on the trunk (Deer Park alpha 2) but not on the branch (Firefox 1.05).

I have no idea if this is a JS issue or a layout issue. But after filing this
bug, I hope someone with more knowledge can chime in.

Graphics and testcase attachments to follow.
Comment 1 Steve England [:stevee] 2005-07-14 05:41:17 PDT
Created attachment 189297 [details]
image 1 for testcase
Comment 2 Steve England [:stevee] 2005-07-14 05:41:38 PDT
Created attachment 189298 [details]
image 2 for testcase
Comment 3 Steve England [:stevee] 2005-07-14 05:41:59 PDT
Created attachment 189299 [details]
image 3 for testcase
Comment 4 Steve England [:stevee] 2005-07-14 05:44:52 PDT
Created attachment 189300 [details]
testcase
Comment 5 Steve England [:stevee] 2005-07-14 05:47:14 PDT
Steps to reproduce

1. Load testcase
2. Hover over the graphical links. Note it does some fancy fade-in for the
colours (which is actually just some trickery involving the image files and some JS)
3. Left click any of the graphical links.

Actual:
Usually the image you clicked on will start to flicker like mad.

Expected:
The link is followed; no flickering is exhibited

This works fine on the branch (1.05) but not on the trunk (Deer Park alpha 2). I
have no idea if this is a JS issue, or a layout issue.
Comment 6 Steve England [:stevee] 2005-07-14 05:48:15 PDT
After clicking a graphical link on the testcase, you might have to move your
mouse left/right ever so slightly in order for the flickering to start up.
Comment 7 Andreas Lange 2005-07-14 06:35:46 PDT
The JS uses onmouseover and onmouseout events to animate the fade-in/out. After
you click the link, the object will get a stream of alternating
onmouseover/onmouseout events causing the flickering as the JS rapidly toggles
the fading effect.

Unless I'm mistaken, this belongs in the event component - neither JS nor Layout.
Comment 8 Ria Klaassen (not reading all bugmail) 2005-07-14 07:30:42 PDT
On 1-1-2005 the links already flickered, but only three times.:)
To get flicker-free links, you need to go back to end July 2004.
Between those dates there were also strange dotted lines through the links..
Comment 9 Steve England [:stevee] 2005-07-14 10:00:59 PDT
There are a bunch of regression ranges here:

In firefox 1.05, the links work as expected when clicked and focused (no flicker)

In early 2004 builds, the links do not flicker when clicked and focused.
In later 2004 builds, the links flicker for a while (1-3 seconds) and then stop.
In early 2005 builds, the links flicker 3 times only when clicked and focused
In most recent builds, the links flicker constantly when clicked and focused



The regression range between 'no flicker' and 'flicker for a while then stop' is
between 2004-07-24-09 (no flicker) and 2004-07-26-14 (flickers for a while then
stops)
Checkin Range
http://bonsai.mozilla.org/cvsquery.cgi?treeid=default&module=all&branch=HEAD&branchtype=match&dir=mozilla%2Flayout%2Fstyle+mozilla%2Flayout%2Fbase+mozilla%2Flayout%2Fgeneric+mozilla%2Feditor%2Flibeditor+mozilla%2Fcontent%2Fevents+mozilla%2Fview%2F&file=&filetype=match&who=&whotype=match&sortby=Date&hours=2&date=explicit&mindate=2004-07-24+08%3A00&maxdate=2004-07-26+14%3A00&cvsroot=%2Fcvsroot
Bug 252948?


I have not bothered to find a regression between 'flicker for a while then stop'
and 'flickers 3 times only'
(Although if this would be useful, I can do)


The regression range between 'flicker 3 times' and 'flicker constantly' is
between 2005-01-19-17 and 2005-01-20-11
Checking Range
http://bonsai.mozilla.org/cvsquery.cgi?treeid=default&module=all&branch=HEAD&branchtype=match&dir=mozilla%2Flayout%2Fstyle+mozilla%2Flayout%2Fbase+mozilla%2Flayout%2Fgeneric+mozilla%2Feditor%2Flibeditor+mozilla%2Fcontent%2Fevents+mozilla%2Fview%2F&file=&filetype=match&who=&whotype=match&sortby=Date&hours=2&date=explicit&mindate=2005-01-19+16%3A00&maxdate=2005-01-20+11%3A00&cvsroot=%2Fcvsroot
Bug 244366 looks guilty in this case


Thanks to Gavin Sharp for some regression range finding.
Comment 10 Boris Zbarsky [:bz] (still a bit busy) 2005-07-14 12:06:32 PDT
So in fact that first regression happened between 2004-07-24-09 and
2004-07-25-07.  I'm almost certain that bug 250006 is what caused it -- notice
that not only does the link start to flicker but it also ends up painted yellow
instead of the white it should be.

Note that you get the same issue on right-click and that tabbing through the
links makes them all yellow (hence my assumption that bug 250006 is the problem).

Aaron, any idea what's going on here?

Martijn, do you think we could end up with a simpler testcase?
Comment 11 Martijn Wargers [:mwargers] (not working for Mozilla) 2005-07-14 13:04:40 PDT
Created attachment 189348 [details]
image for testcase2
Comment 12 Martijn Wargers [:mwargers] (not working for Mozilla) 2005-07-14 13:16:52 PDT
Created attachment 189351 [details]
testcase2

This is what I think is going on:
1- When focusing the link, Mozilla shifts the link with the image inside to the
bottom in a (failing) attempt to get the focused content in view.
2- When mouseovering the image, the script says to move it 21px up, that means
the image's position gets higher than the mouse position -> a mousout event is
fired.
3- Then the domouseout function gets done, it tells the image to position
itself 21px lower, the mouse gets again over the image -> a mouseover event is
fired and step 2 is again followed, etc. 

So an endless loop is created this way.
You can more easily see this when the containing div has overflow:visible
(click on the button) and then moving the mouse from below the image into the
image.
Comment 13 Asa Dotzler [:asa] 2005-07-22 14:25:29 PDT
we'd consider taking a patch for this if one happens but I don't think we're
going to block on a year old regression.
Comment 14 Martijn Wargers [:mwargers] (not working for Mozilla) 2005-07-31 15:04:17 PDT
I think this is basically exposed by the fix for bug 20022, but it should be
(partially) fixed when bug 105894 gets fixed.
Comment 15 Masayuki Nakano [:masayuki] (Mozilla Japan) (Offline: 9/19, 9/22-9/25, 9/28)) 2005-09-18 04:34:11 PDT
fixed by bug 105894.
Comment 16 Jay Patel [:jay] 2006-01-11 16:02:21 PST
v.fixed on 1.8.0.1 with Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.1) Gecko/20060111 Firefox/1.5.0.1, appears to be fixed based on testcase2 in comment #12.

Note You need to log in before you can comment on or make changes to this bug.